package plist

import (
	"errors"
	"log"

	"github.com/davecgh/go-spew/spew"

	"github.com/emirpasic/gods/trees/binaryheap"

	"github.com/emirpasic/gods/utils"
)

// PriorityQueue 优先队列 适合数据量不大, 加索引
type PriorityQueue struct {
	heaps    []*binaryheap.Heap
	heapsCap int
	cursor   int

	splitlimit int
	size       int
	comparator utils.Comparator
}

func (pq *PriorityQueue) String() string {

	content := ""

	for i := pq.cursor; i < pq.heapsCap; i++ {
		content += spew.Sprint(pq.heaps[i].Values()) + "--"
	}

	return content
}

func NewWithIntComparator() *PriorityQueue {
	pq := new(PriorityQueue)
	pq.splitlimit = 20
	pq.heapsCap = 10
	pq.heaps = make([]*binaryheap.Heap, pq.heapsCap, pq.heapsCap)
	pq.cursor = pq.heapsCap - 1

	pq.comparator = func(v1, v2 interface{}) int {
		if v1.(int) > v2.(int) {
			return 1
		} else if v1.(int) < v2.(int) {
			return -1
		}
		return 0
	}
	pq.heaps[pq.cursor] = binaryheap.NewWith(pq.comparator)
	return pq
}

func (pq *PriorityQueue) Push(value interface{}) {
	pq.size++

	curheap := pq.heaps[pq.cursor]
	log.Println(pq.heaps)
	if curheap.Size() >= pq.splitlimit {
		if pq.cursor == 0 {
			// remake
		}
		pq.cursor--
		heap := binaryheap.NewWith(pq.comparator)
		heap.Push(value)
		for i := 0; i < pq.splitlimit/2-1; i++ {
			v, ok := curheap.Pop()
			if !ok {
				panic(errors.New("size is error?"))
			}
			heap.Push(v)
		}
		pq.heaps[pq.cursor] = heap

	} else {
		curheap.Push(value)
	}

	return

}
